/*****************************************************************************
    Ethernet packet sniffer - GreedyDog2

    Developed by Shadow Penguin Security Resarch Group
     http://www.shadowpenguin.org
     UNYUN <unyun@shadowpenguin.org>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.
 *****************************************************************************/

#include <stdio.h>
#include "depend.h"
#include "gdd_printf.h"

int  (*gdd_printf)(char *,...);

/*============================================================================
 printf to console
 [INPUT]
    format      : print format (same as printf)
 [RETURN]
    return value of vsnprintf
  ============================================================================
*/
#ifdef WIN32
int console_printf(char *format,...)
{
    int             r;
    unsigned int    i,j;
    va_list         args;
    static char     cbuf[512],xbuf[1024];

    va_start(args, format);
    r=_vsnprintf(cbuf,sizeof(cbuf)-1,format,args);
    va_end(args);
    for (j=i=0;i<strlen(cbuf);i++){
        if (cbuf[i]=='\n'){
            if (i>=1){
                if (cbuf[i-1]!='\r'){
                    xbuf[j]='\r';
                    xbuf[j+1]='\n';
                    j+=2;
                }
            }else{
                xbuf[j]='\r';
                xbuf[j+1]='\n';
                j+=2;
            }
        }else{
            xbuf[j]=cbuf[i];
            j++;
        }
    }
    xbuf[j]='\0';
    console_write(xbuf);
    return(r);
}
#endif

/*============================================================================
 write to console
 [INPUT]
    flag        : 0=Do not use console_printf, 1=Use console_printf
 [RETURN]
    none
  ============================================================================
*/
void init_gddprintf(int flag)
{
#ifndef WIN32
    gdd_printf=(void *)printf;
#else
    if (flag) gdd_printf=console_printf;
    else gdd_printf=printf;
#endif
}
