/*****************************************************************************
    Ethernet packet sniffer - GreedyDog2

    Developed by Shadow Penguin Security Resarch Group
     http://www.shadowpenguin.org
     UNYUN <unyun@shadowpenguin.org>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    Thanks! : hsj <hsj@shadowpengin.org> helps me to develop this code!

 *****************************************************************************/

#include <unistd.h>
#include <stdio.h>
#include "depend.h"
#include "param.h"
#include "promisc.h"
#include "analyze.h"
#include "gddconfig.h"
#include "error.h"
#include "analyze.h"

/*============================================================================
 Main loop (read packet and analyze it)
 [INPUT]
  gddc          : Configuration data of gdd
 [RETURN]
  none
  ============================================================================
*/
void sniffloop(GDDCONFIG *gddc)
{
	struct etherpacket      ep;
	SOCKET                  sock;

	if (init_connection_table()){
		errorlog(ERRLOG_FATAL,"Can not initialize contable\n");
		return;
	}
	if ((sock=setnic_promisc(gddc->nit_dev,gddc->nic_name,NULL))<0){
		errorlog(ERRLOG_FATAL,"setnic_promisc error (%d)\n",sock);
		release_connection_table();
		return;
	}
	for (;;){
		if (read(sock,&ep,sizeof(ep))>0){
			if (ep.ether.ether_type!=htons(ETHERTYPE_IP))
				continue;
			if (packet_analysis(gddc,(void *)&(ep.ether),
			    ep.snoop.snoop_packetlen)){
				release_connection_table();
				return;
			}
		}
	}
}
